<?
require_once('template.php');
require_once('config.php');
// Get the filelist for left panel
function checkInstall(){
	global $filesdir;
	if (!is_dir($filesdir)){mkdir($filesdir,0777);}
	foreach (scandir($filesdir) as $file){
		if (substr($file,-6,6)!='server'){
			continue;			
		}
		$fopen = fopen($filesdir . $file,'r');
		$content = fread($fopen, filesize($filesdir . $file));
		fclose($fopen);
		if (substr_count($content,' ') != 2){
			$content = '0 ' . $content;
			$fopen = fopen($filesdir . $file,'w');
			fwrite($file,$content);
			fclose($fopen);
		}
	}
}
function getFileListTPL (){
	global $template;
	global $filesdir;
	// Create the data folder if it doesn't exist
	$filelist = '<div class="newfile"><a class="filelist" href="index.php?action=newfile">New File</a></div>';
	foreach (scandir($filesdir) as $file){
		if (substr($file,-4,4)!='info'){
			continue;			
		}
		$fopen = fopen($filesdir . $file,'r');
		$content = explode(' ',fread($fopen, filesize($filesdir . $file)),2);
		fclose($fopen);
		$vars = array();
		$vars['name'] = substr($file,0,-5);
		$vars['path'] = $content[1];
		$filelist .= template($vars,'filelist',$template);
	}
	if ($filelist == '') {
		$filelist = 'No files found';
	}
	return $filelist;	
}
// Get the serverlist for right panel
function getServerListTPL(){
	global $filesdir;
	global $template;
	// Create the data folder if it doesn't exist
	$list = array();
	$found = false;
	foreach (scandir($filesdir) as $file){
		if (substr($file,-6,6)!='server'){
			continue;			
		}
		$fopen = fopen($filesdir . $file,'r');
		$content = explode(' ',fread($fopen, filesize($filesdir . $file)),2);
		$server = explode('_',substr($file,0,strlen($file)-6));
		fclose($fopen);
		$list[$content[1]] = array('oldveresion'=>$content[0],'name'=>$content[2],'ip'=>$server[0],'port'=>$server[1]);
		$found = true;
	}
	if ($found){
		arsort($list);
		$serverlist = '';
		foreach ($list as $timestamp=>$server){
			$vars = array();
			$vars['time'] = strftime("%D - %T",floatval($timestamp));
			$vars['servername'] = $server['name'];
			$vars['serverip'] = $server['ip'];
			$vars['serverport'] = $server['port'];
			if ($server['oldversion'] == '1'){
				$vars['oldversion'] = template(array(),'oldversion',$template);
			} else {
				$vars['oldversion'] = '';
			}
			$serverlist .= template($vars,'serverlist',$template);
		}
	} else {
		$serverlist = 'No servers found';
	}
	return $serverlist;
}
// Get a file's content, path and timestamp
function getFile($name) {
	global $filesdir;
	$fpath = $filesdir . $name . '.info';
	$fopen = fopen($fpath,'r');
	$content = explode(' ',fread($fopen, filesize($fpath)),2);
	fclose($fopen);
	$timestamp =  $content[0];
	$path = $content[1];
	$fpath = $filesdir . $name . '.content';
	$fopen = fopen($fpath,'r');
	$content = fread($fopen,filesize($fpath));
	return array($content,$path,$timestamp);
}
// Write a file and update info file
function writeFile($path,$name,$content){
	global $filesdir;
	$file = fopen($filesdir . $name . '.content','w');
	fwrite($file,$content);
	fclose($file);
	$file = fopen($filesdir . $name . '.info','w');
	fwrite($file,time() . ' ' . $path);
	fclose($file);
}
// Delete a file and its info
function deleteFile($name){
	global $filesdir;
	unlink($filesdir . $name . '.info');
	unlink($filesdir . $name . '.content');
}
// Get a list of files (for interface)
function getFileList(){
	global $filesdir;
	$filelist = array();
	foreach (scandir($filesdir) as $file){
		if (substr($file,-4,4)!='info'){
			continue;
		}
		$fopen = fopen($filesdir . $file,'r');
		$content = fread($fopen, filesize($filesdir . $file));
		fclose($fopen);
		$filelist[] = $content; 
	}
	return implode('\n',$filelist);	
}
function serverUpdate($servername, $ip, $port){
	global $filesdir;
	$fpath = $filesdir . $ip . '_' . $port . '.server';
	$file = fopen($fpath,'w');
	fwrite($file,'0 ' . time() . ' ' . $servername);
	fclose($file);
}
function oldVersion($ip,$port){
	global $filesdir;
	$fpath = $filesdir . $ip . '_' . $port . '.server';
	$file = fopen($fpath,'r');
	$content = fread($file,filesize($fpath));
	fclose($file);
	$content = '1' . substr($content,1);
	$file = fopen($fpath,'w');
	fwrite($file,$content);
	fclose($file);
}
function currentVersion($ip,$port){
	global $filesdir;
	$fpath = $filesdir . $ip . '_' . $port . '.server';
	$file = fopen($fpath,'r');
	$content = fread($file,filesize($fpath));
	fclose($file);
	$content = '0' . substr($content,1);
	$file = fopen($fpath,'w');
	fwrite($file,$content);
	fclose($file);
}
?>